#!/usr/bin/env python

import sys
import subprocess

""" 
def get_command_with_keywords(command, keywords) -> list[str]:
    matching_lines = []
    try:
        output = subprocess.check_output(command, text=True)
        for line in output.splitlines():
            print(line)

            lines = line.split()
            print(f"{lines}")

            match = True 
            for keyword in keywords:
                if keyword[0] == "!": 
                    if keyword[1:] in line:
                        match = False
                else:
                    if keyword not in line:
                        match = False
                if match == False:
                    break
            if match == True:
                matching_lines.append(line)
    except subprocess.CalledProcessError as error:
        print(f"Command failed with error: {error.stderr}")   
    return matching_lines

 """


def get_command_with_keywords(command, keywords) -> list[str]:
    matching_lines = []
    try:
        output = subprocess.check_output(command, text=True)
        for line in output.splitlines():
            print(f"{line}")
            words = line.split()
            match = True
            for keyword in keywords:
                if keyword[0] != "!":
                    word_match = False
                    for word in words:
                        if word == keyword:
                            word_match = True
                            break
                else:
                    word_match = True
                    for word in words:
                        if word == keyword:
                            word_match = False
                            break
                print(f"{keyword} {word_match} {match}")
                if word_match is False:
                    match = False
                    break
            if match is True:
                matching_lines.append(line)
    except subprocess.CalledProcessError as error:
        print(f"Command failed with error: {error.stderr}")   
    return matching_lines




def combine_connection_str(line: str, offset: int, size: int) -> str:
    connection = ""
    lines = line.split()
    for i in range(offset, offset + len(lines) - (size - 1)):
        connection += f"{lines[i]} "
    connection = connection[:-1]
    return connection




def get_gsm_connected() -> (str, str):
    try:
        device = ""
        #line = get_command_with_keywords(["nmcli", "dev"], ["gsm", "connected", "!disconnected"])
        line = get_command_with_keywords(["nmcli", "dev"], ["gsm", "connected"])
        lines = line[0].split()
        device = lines[0]
        connection = combine_connection_str(line[0], 3, 4)
        return device, connection
    except IndexError:
        return "", ""


def get_all_gsm_down() -> list[str]:
    lines = get_command_with_keywords(["nmcli", "con", "show"], ["gsm", "--"])
    return lines


def get_all_gsm_up() -> list[str]:
    lines = get_command_with_keywords(["nmcli", "con", "show"], ["gsm", "!--"])
    return lines


def delete_all_gsm_down():
    output = get_all_gsm_down()
    for line in output:
        connection = combine_connection_str(line, 0, 4)
        print(connection)
        continue
        try:
            output = subprocess.check_output(["nmcli", "con", "delete", connection], text=True)
            print(output)
        except subprocess.CalledProcessError as error:
            print(f"Command failed with return code {error.returncode}")

def delete_all_gsm_up():
    output = get_all_gsm_up()
    for line in output:
        connection = combine_connection_str(line, 0, 4)
        print(connection)
        continue
        try:
            output = subprocess.check_output(["nmcli", "con", "delete", connection], text=True)
            print(output)
        except subprocess.CalledProcessError as error:
            print(f"Command failed with return code {error.returncode}")


def is_gsm_available() -> (bool, str):
    try:
        line = get_command_with_keywords(["nmcli", "dev"], ["gsm", "!unavailable"])
        lines = line[0].split()
        device = lines[0]
        return True, device
    except IndexError:
        return False, ""




def add_apn(name: str, apn: str, username: str | None = None, password: str | None = None, ifname: str = "cdc-wdm0"):

    try:
        # output = subprocess.check_output(["nmcli", "con", "add", "type", "gsm", "ifname", ifname, "con-name", name, "apn", apn, "user", username, "password", password, "ipv4.method", "auto"], text=True)
        output = subprocess.check_output(["nmcli", "con", "add", "type", "gsm", "ifname", ifname, "con-name", name, "apn", apn, "ipv4.method", "auto"], text=True)
        print(output)

        if username is not None:
            output = subprocess.check_output(["nmcli", "con", "modify", name, "gsm.user", username], text=True)
            print(output)

        if password is not None:
            output = subprocess.check_output(["nmcli", "con", "modify", name, "gsm.password", password], text=True)
            print(output)
        
        
        print(output)
    except subprocess.CalledProcessError as error:
        print(f"Command failed with return code {error.returncode}")




def main():

    #print("Available:")
    #available, device = is_gsm_available()
    #print(f"{available} {device}\n")

    print("Connection:")
    device, connection = get_gsm_connected()
    print(f"{device} {connection}\n")

    sys.exit(0)

    print("Down:")
    delete_all_gsm_down()
    print("\n")

    print("Up:")
    delete_all_gsm_up()

    sys.exit(0)

    
   


if __name__ == "__main__":
    sys.exit(main())